#! /usr/bin/python
# coding: UTF-8

# flask_hts.py python http WEBサーバ サンプルプログラム
# 実行コマンド(例): python flask_hts.py
#
# テンプレートなどのフォルダ構成は以下の通りです。
#
# [flask_hts.py][本体] (/var/www/の下を推奨)
#     |
#     |-[templates]フォルダ - [mainst.html](htmlテンプレート)
#     |                       (他のhtmlファイルもここに置く)
#     |
#     |-[static]フォルダ　　- [style.css](スタイルシート)
#                             (他の画像などもここに置く)


from flask import Flask, render_template, request, url_for, redirect
import csv
import subprocess

app = Flask(__name__)

conffile = '/home/pi/work/rht.conf'
conf = {}

def exeCom(cargs) :
  dex = subprocess.Popen(cargs,
            stdin=subprocess.PIPE,
            stdout=subprocess.PIPE,
            stderr=subprocess.PIPE,
            shell=False)
  print (dex.stdout.readlines(),)

def openDict() :
  drise = {}
  dfall = {}
  fc = open(conffile,'r+')
  reader = csv.reader(fc)
  for row in reader :
	if row[0] == 'ST' :
	  conf[row[1]] = row[2]
        elif row[0] == 'RISE' :
	  drise[row[1]] = row[2]
        elif row[0] == 'FALL' :
	  dfall[row[1]] = row[2]
        else:
          pass
  fc.close()
  conf['RISE'] = dict(drise)
  conf['FALL'] = dict(dfall)
  return

@app.route('/<action>')
def act_tgl(action):
  if action == 'TGL_EDGE' :
        targs = ['/home/pi/work/mainrht.py', 'SW_PLS']
        exeCom(targs)

  elif action == 'TGL_DET' :
        targs = ['/home/pi/work/mainrht.py', 'SW_LONG']
        exeCom(targs)

  return redirect(url_for('root_index'))


@app.route('/')
def root_index():
   openDict()
   return render_template('mainst.html', **conf)

if __name__ == '__main__':
   app.run(host='192.168.0.5', port=3000, debug=True)
